Package com.io7m.waxmill.machines

# Class WXMDeviceLPC

java.lang.Object
com.io7m.waxmill.machines.WXMDeviceLPC

All Implemented Interfaces:
  `WXMDeviceType`, `WXMDeviceType.WXMDeviceLPCType`

    public final class WXMDeviceLPC
    extends java.lang.Object
    implements WXMDeviceType.WXMDeviceLPCType

Immutable implementation of `WXMDeviceType.WXMDeviceLPCType`.

Use the builder to create immutable instances: `WXMDeviceLPC.builder()`.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXMDeviceLPC.Builder` | Builds instances of type `WXMDeviceLPC`.

  ## Nested classes/interfaces inherited from interface com.io7m.waxmill.machines.WXMDeviceType

  `WXMDeviceType.Kind, WXMDeviceType.WXMDeviceAHCIDiskType, WXMDeviceType.WXMDeviceAHCIOpticalDiskType, WXMDeviceType.WXMDeviceE1000Type, WXMDeviceType.WXMDeviceFramebufferType, WXMDeviceType.WXMDeviceHostBridgeType, WXMDeviceType.WXMDeviceLPCType, WXMDeviceType.WXMDevicePassthruType, WXMDeviceType.WXMDeviceVirtioBlockStorageType, WXMDeviceType.WXMDeviceVirtioNetworkType, WXMDeviceType.WXMLPCTTYNames, WXMDeviceType.WXMNetworkDeviceBackendType, WXMDeviceType.WXMSectorSizesType, WXMDeviceType.WXMStorageBackendFileType, WXMDeviceType.WXMStorageBackendType, WXMDeviceType.WXMStorageBackendZFSVolumeType, WXMDeviceType.WXMTapType, WXMDeviceType.WXMTTYBackendFileType, WXMDeviceType.WXMTTYBackendNMDMType, WXMDeviceType.WXMTTYBackendStdioType, WXMDeviceType.WXMTTYBackendType, WXMDeviceType.WXMVMNetType`

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `java.util.Map<java.lang.String,​WXMDeviceType.WXMTTYBackendType>` | `backendMap()` |
  `java.util.List<WXMDeviceType.WXMTTYBackendType>` | `backends()` |
  `static WXMDeviceLPC.Builder` | `builder()` | Creates a builder for `WXMDeviceLPC`.
  `java.lang.String` | `comment()` |
  `static WXMDeviceLPC` | `copyOf​(WXMDeviceType.WXMDeviceLPCType instance)` | Creates an immutable copy of a `WXMDeviceType.WXMDeviceLPCType` value.
  `WXMDeviceSlot` | `deviceSlot()` |
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXMDeviceLPC` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `deviceSlot`, `comment`, `backends`.
  `java.lang.String` | `toString()` | Prints the immutable value `WXMDeviceLPC` with attribute values.
  `WXMDeviceLPC` | `withBackends​(WXMDeviceType.WXMTTYBackendType... elements)` | Copy the current immutable object with elements that replace the content of `backends`.
  `WXMDeviceLPC` | `withBackends​(java.lang.Iterable<? extends WXMDeviceType.WXMTTYBackendType> elements)` | Copy the current immutable object with elements that replace the content of `backends`.
  `WXMDeviceLPC` | `withComment​(java.lang.String value)` | Copy the current immutable object by setting a value for the `comment` attribute.
  `WXMDeviceLPC` | `withDeviceSlot​(WXMDeviceSlot value)` | Copy the current immutable object by setting a value for the `deviceSlot` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.waxmill.machines.WXMDeviceType

  `isConsoleDevice, isStorageDevice`

  ### Methods inherited from interface com.io7m.waxmill.machines.WXMDeviceType.WXMDeviceLPCType

  `checkPreconditions, externalName, kind`

- ## Method Details

  - ### deviceSlot

    public WXMDeviceSlot deviceSlot()
    Specified by:
      `deviceSlot` in interface `WXMDeviceType`
    Specified by:
      `deviceSlot` in interface `WXMDeviceType.WXMDeviceLPCType`
    Returns:
      The value of the `deviceSlot` attribute

  - ### comment

    public java.lang.String comment()
    Specified by:
      `comment` in interface `WXMDeviceType`
    Specified by:
      `comment` in interface `WXMDeviceType.WXMDeviceLPCType`
    Returns:
      The value of the `comment` attribute

  - ### backends

    public java.util.List<WXMDeviceType.WXMTTYBackendType> backends()
    Specified by:
      `backends` in interface `WXMDeviceType.WXMDeviceLPCType`
    Returns:
      The value of the `backends` attribute

  - ### backendMap

    public java.util.Map<java.lang.String,​WXMDeviceType.WXMTTYBackendType> backendMap()
    Specified by:
      `backendMap` in interface `WXMDeviceType.WXMDeviceLPCType`
    Returns:
      The computed-at-construction value of the `backendMap` attribute

  - ### withDeviceSlot

    public final WXMDeviceLPC withDeviceSlot​(WXMDeviceSlot value)
    Copy the current immutable object by setting a value for the `deviceSlot` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for deviceSlot
    Returns:
      A modified copy of the `this` object

  - ### withComment

    public final WXMDeviceLPC withComment​(java.lang.String value)
    Copy the current immutable object by setting a value for the `comment` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for comment
    Returns:
      A modified copy of the `this` object

  - ### withBackends

    public final WXMDeviceLPC withBackends​(WXMDeviceType.WXMTTYBackendType... elements)
    Copy the current immutable object with elements that replace the content of `backends`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withBackends

    public final WXMDeviceLPC withBackends​(java.lang.Iterable<? extends WXMDeviceType.WXMTTYBackendType> elements)
    Copy the current immutable object with elements that replace the content of `backends`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of backends elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXMDeviceLPC` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `deviceSlot`, `comment`, `backends`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXMDeviceLPC` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static WXMDeviceLPC copyOf​(WXMDeviceType.WXMDeviceLPCType instance)
    Creates an immutable copy of a `WXMDeviceType.WXMDeviceLPCType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXMDeviceLPC instance

  - ### builder

    public static WXMDeviceLPC.Builder builder()
    Creates a builder for `WXMDeviceLPC`.

         WXMDeviceLPC.builder()
            .setDeviceSlot(com.io7m.waxmill.machines.WXMDeviceSlot) // required deviceSlot
            .setComment(String) // optional comment
            .addBackends|addAllBackends(com.io7m.waxmill.machines.WXMDeviceType.WXMTTYBackendType) // backends elements
            .build();

    Returns:
      A new WXMDeviceLPC builder